/* Audio.c generated by valac 0.56.17, the Vala compiler
 * generated from Audio.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2015-2018 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Felipe Escoto <felescoto95@hotmail.com>
 */

#include "accessibility.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <gtk/gtk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	ACCESSIBILITY_PANES_AUDIO_0_PROPERTY,
	ACCESSIBILITY_PANES_AUDIO_SCREENREADER_SHORTCUT_KEYS_PROPERTY,
	ACCESSIBILITY_PANES_AUDIO_NUM_PROPERTIES
};
static GParamSpec* accessibility_panes_audio_properties[ACCESSIBILITY_PANES_AUDIO_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block2Data Block2Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _AccessibilityPanesAudioPrivate {
	gchar* _screenreader_shortcut_keys;
};

struct _Block2Data {
	int _ref_count_;
	AccessibilityPanesAudio* self;
	GtkLabel* shortcut_label;
};

static gint AccessibilityPanesAudio_private_offset;
static gpointer accessibility_panes_audio_parent_class = NULL;
static GSettings* accessibility_panes_audio_media_keys_settings;
static GSettings* accessibility_panes_audio_media_keys_settings = NULL;

static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static GObject * accessibility_panes_audio_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void _accessibility_panes_audio___lambda4_ (Block2Data* _data2_);
static void __accessibility_panes_audio___lambda4__g_settings_changed (GSettings* _sender,
                                                                const gchar* key,
                                                                gpointer self);
static void accessibility_panes_audio_finalize (GObject * obj);
static GType accessibility_panes_audio_get_type_once (void);
static void _vala_accessibility_panes_audio_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
accessibility_panes_audio_get_instance_private (AccessibilityPanesAudio* self)
{
	return G_STRUCT_MEMBER_P (self, AccessibilityPanesAudio_private_offset);
}

AccessibilityPanesAudio*
accessibility_panes_audio_construct (GType object_type)
{
	AccessibilityPanesAudio * self = NULL;
#line 40 "../src/Panes/Audio.vala"
	self = (AccessibilityPanesAudio*) g_object_new (object_type, "label-string", _ ("Audio"), "icon-name", "preferences-desktop-sound", NULL);
#line 39 "../src/Panes/Audio.vala"
	return self;
#line 112 "Audio.c"
}

AccessibilityPanesAudio*
accessibility_panes_audio_new (void)
{
#line 39 "../src/Panes/Audio.vala"
	return accessibility_panes_audio_construct (ACCESSIBILITY_PANES_TYPE_AUDIO);
#line 120 "Audio.c"
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 31 "../src/Panes/Audio.vala"
	if ((*length) == (*size)) {
#line 31 "../src/Panes/Audio.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 31 "../src/Panes/Audio.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 135 "Audio.c"
	}
#line 31 "../src/Panes/Audio.vala"
	(*array)[(*length)++] = value;
#line 31 "../src/Panes/Audio.vala"
	(*array)[*length] = NULL;
#line 141 "Audio.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1251 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1252 "glib-2.0.vapi"
		separator = "";
#line 155 "Audio.c"
	}
#line 1254 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 159 "Audio.c"
		gboolean _tmp1_ = FALSE;
#line 1254 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1254 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 165 "Audio.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1254 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 170 "Audio.c"
				const gchar* _tmp3_;
#line 1254 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1254 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 176 "Audio.c"
			} else {
#line 1254 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 180 "Audio.c"
			}
#line 1254 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 184 "Audio.c"
		}
#line 1254 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 188 "Audio.c"
	} else {
#line 1254 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 192 "Audio.c"
	}
#line 1254 "glib-2.0.vapi"
	if (_tmp0_) {
#line 196 "Audio.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1256 "glib-2.0.vapi"
		len = (gsize) 1;
#line 211 "Audio.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
			i = 0;
#line 1257 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1257 "glib-2.0.vapi"
			while (TRUE) {
#line 220 "Audio.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1257 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 227 "Audio.c"
					gint _tmp5_;
#line 1257 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1257 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 233 "Audio.c"
				}
#line 1257 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 241 "Audio.c"
				} else {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 245 "Audio.c"
				}
#line 1257 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1257 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 251 "Audio.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1257 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 256 "Audio.c"
						const gchar* _tmp9_;
#line 1257 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1257 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 262 "Audio.c"
					} else {
#line 1257 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 266 "Audio.c"
					}
#line 1257 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 270 "Audio.c"
				}
#line 1257 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1257 "glib-2.0.vapi"
					break;
#line 276 "Audio.c"
				}
#line 1258 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1258 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 282 "Audio.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1258 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1258 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1258 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1258 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 294 "Audio.c"
				} else {
#line 1258 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 298 "Audio.c"
				}
#line 1258 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 302 "Audio.c"
			}
		}
#line 1260 "glib-2.0.vapi"
		if (i == 0) {
#line 307 "Audio.c"
			gchar* _tmp15_;
#line 1261 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1261 "glib-2.0.vapi"
			result = _tmp15_;
#line 1261 "glib-2.0.vapi"
			return result;
#line 315 "Audio.c"
		}
#line 1263 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1264 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1264 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1264 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1266 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1266 "glib-2.0.vapi"
		res = _tmp18_;
#line 1267 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1267 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 333 "Audio.c"
			const gchar* _tmp21_;
#line 1267 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1267 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 339 "Audio.c"
		} else {
#line 1267 "glib-2.0.vapi"
			_tmp19_ = "";
#line 343 "Audio.c"
		}
#line 1267 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1267 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1267 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 351 "Audio.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
			i = 1;
#line 1268 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1268 "glib-2.0.vapi"
			while (TRUE) {
#line 360 "Audio.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1268 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 369 "Audio.c"
					gint _tmp25_;
#line 1268 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1268 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 375 "Audio.c"
				}
#line 1268 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1268 "glib-2.0.vapi"
					break;
#line 383 "Audio.c"
				}
#line 1269 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1269 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1269 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1270 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1270 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 395 "Audio.c"
					const gchar* _tmp30_;
#line 1270 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1270 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 401 "Audio.c"
				} else {
#line 1270 "glib-2.0.vapi"
					_tmp28_ = "";
#line 405 "Audio.c"
				}
#line 1270 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1270 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1270 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 413 "Audio.c"
			}
		}
#line 1273 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1273 "glib-2.0.vapi"
		res = NULL;
#line 1273 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1273 "glib-2.0.vapi"
		return result;
#line 424 "Audio.c"
	} else {
		gchar* _tmp34_;
#line 1275 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1275 "glib-2.0.vapi"
		result = _tmp34_;
#line 1275 "glib-2.0.vapi"
		return result;
#line 433 "Audio.c"
	}
}

const gchar*
accessibility_panes_audio_get_screenreader_shortcut_keys (AccessibilityPanesAudio* self)
{
	const gchar* result;
	gchar** granite_accel_strings = NULL;
	gint granite_accel_strings_length1;
	gint _granite_accel_strings_size_;
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gchar* _tmp7_;
	const gchar* _tmp8_;
#line 28 "../src/Panes/Audio.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../src/Panes/Audio.vala"
	granite_accel_strings = NULL;
#line 29 "../src/Panes/Audio.vala"
	granite_accel_strings_length1 = 0;
#line 29 "../src/Panes/Audio.vala"
	_granite_accel_strings_size_ = granite_accel_strings_length1;
#line 30 "../src/Panes/Audio.vala"
	_tmp0_ = accessibility_panes_audio_media_keys_settings;
#line 30 "../src/Panes/Audio.vala"
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, "screenreader");
#line 463 "Audio.c"
	{
		gchar** key_collection = NULL;
		gint key_collection_length1 = 0;
		gint _key_collection_size_ = 0;
		gint key_it = 0;
#line 30 "../src/Panes/Audio.vala"
		key_collection = _tmp2_;
#line 30 "../src/Panes/Audio.vala"
		key_collection_length1 = _vala_array_length (_tmp1_);
#line 30 "../src/Panes/Audio.vala"
		for (key_it = 0; key_it < key_collection_length1; key_it = key_it + 1) {
#line 475 "Audio.c"
			gchar* _tmp3_;
			gchar* key = NULL;
#line 30 "../src/Panes/Audio.vala"
			_tmp3_ = g_strdup (key_collection[key_it]);
#line 30 "../src/Panes/Audio.vala"
			key = _tmp3_;
#line 482 "Audio.c"
			{
				const gchar* _tmp4_;
				gchar* _tmp5_;
#line 31 "../src/Panes/Audio.vala"
				_tmp4_ = key;
#line 31 "../src/Panes/Audio.vala"
				_tmp5_ = granite_accel_to_string (_tmp4_);
#line 31 "../src/Panes/Audio.vala"
				_vala_array_add1 (&granite_accel_strings, &granite_accel_strings_length1, &_granite_accel_strings_size_, _tmp5_);
#line 30 "../src/Panes/Audio.vala"
				_g_free0 (key);
#line 494 "Audio.c"
			}
		}
#line 30 "../src/Panes/Audio.vala"
		key_collection = (_vala_array_free (key_collection, key_collection_length1, (GDestroyNotify) g_free), NULL);
#line 499 "Audio.c"
	}
#line 34 "../src/Panes/Audio.vala"
	_tmp6_ = granite_accel_strings;
#line 34 "../src/Panes/Audio.vala"
	_tmp6__length1 = granite_accel_strings_length1;
#line 34 "../src/Panes/Audio.vala"
	_tmp7_ = _vala_g_strjoinv (_ (", "), _tmp6_, (gint) _tmp6__length1);
#line 34 "../src/Panes/Audio.vala"
	_g_free0 (self->priv->_screenreader_shortcut_keys);
#line 34 "../src/Panes/Audio.vala"
	self->priv->_screenreader_shortcut_keys = _tmp7_;
#line 35 "../src/Panes/Audio.vala"
	_tmp8_ = self->priv->_screenreader_shortcut_keys;
#line 35 "../src/Panes/Audio.vala"
	result = _tmp8_;
#line 35 "../src/Panes/Audio.vala"
	granite_accel_strings = (_vala_array_free (granite_accel_strings, granite_accel_strings_length1, (GDestroyNotify) g_free), NULL);
#line 35 "../src/Panes/Audio.vala"
	return result;
#line 519 "Audio.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 50 "../src/Panes/Audio.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 50 "../src/Panes/Audio.vala"
	return _data2_;
#line 529 "Audio.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 50 "../src/Panes/Audio.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 539 "Audio.c"
		AccessibilityPanesAudio* self;
#line 50 "../src/Panes/Audio.vala"
		self = _data2_->self;
#line 50 "../src/Panes/Audio.vala"
		_g_object_unref0 (_data2_->shortcut_label);
#line 50 "../src/Panes/Audio.vala"
		_g_object_unref0 (self);
#line 50 "../src/Panes/Audio.vala"
		g_slice_free (Block2Data, _data2_);
#line 549 "Audio.c"
	}
}

static void
_accessibility_panes_audio___lambda4_ (Block2Data* _data2_)
{
	AccessibilityPanesAudio* self;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 68 "../src/Panes/Audio.vala"
	self = _data2_->self;
#line 69 "../src/Panes/Audio.vala"
	_tmp0_ = _data2_->shortcut_label;
#line 69 "../src/Panes/Audio.vala"
	_tmp1_ = accessibility_panes_audio_get_screenreader_shortcut_keys (self);
#line 69 "../src/Panes/Audio.vala"
	_tmp2_ = _tmp1_;
#line 69 "../src/Panes/Audio.vala"
	gtk_label_set_label (_tmp0_, _tmp2_);
#line 570 "Audio.c"
}

static void
__accessibility_panes_audio___lambda4__g_settings_changed (GSettings* _sender,
                                                           const gchar* key,
                                                           gpointer self)
{
#line 68 "../src/Panes/Audio.vala"
	_accessibility_panes_audio___lambda4_ (self);
#line 580 "Audio.c"
}

static GObject *
accessibility_panes_audio_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AccessibilityPanesAudio * self;
	Block2Data* _data2_;
	GraniteHeaderLabel* reader_label = NULL;
	GraniteHeaderLabel* _tmp0_;
	AccessibilityWidgetsSettingsBox* reader_box = NULL;
	AccessibilityWidgetsSettingsBox* _tmp1_;
	GtkSwitch* read_items = NULL;
	AccessibilityWidgetsSettingsBox* _tmp2_;
	GtkSwitch* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GtkLabel* _tmp6_;
	AccessibilityWidgetsSettingsBox* _tmp7_;
	GtkLabel* _tmp8_;
	AccessibilityWidgetsLinkLabel* audio_settings = NULL;
	AccessibilityWidgetsLinkLabel* _tmp9_;
	AccessibilityWidgetsLinkLabel* _tmp10_;
	GtkGrid* _tmp11_;
	GtkGrid* _tmp12_;
	GraniteHeaderLabel* _tmp13_;
	GtkGrid* _tmp14_;
	GtkGrid* _tmp15_;
	AccessibilityWidgetsSettingsBox* _tmp16_;
	GtkGrid* _tmp17_;
	GtkGrid* _tmp18_;
	AccessibilityWidgetsLinkLabel* _tmp19_;
	GtkGrid* _tmp20_;
	GtkGrid* _tmp21_;
	GSettings* _tmp22_;
	GtkSwitch* _tmp23_;
	GSettings* _tmp24_;
#line 50 "../src/Panes/Audio.vala"
	parent_class = G_OBJECT_CLASS (accessibility_panes_audio_parent_class);
#line 50 "../src/Panes/Audio.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 50 "../src/Panes/Audio.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ACCESSIBILITY_PANES_TYPE_AUDIO, AccessibilityPanesAudio);
#line 50 "../src/Panes/Audio.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 50 "../src/Panes/Audio.vala"
	_data2_->_ref_count_ = 1;
#line 50 "../src/Panes/Audio.vala"
	_data2_->self = g_object_ref (self);
#line 51 "../src/Panes/Audio.vala"
	_tmp0_ = granite_header_label_new (_ ("Screen Reader"));
#line 51 "../src/Panes/Audio.vala"
	g_object_ref_sink (_tmp0_);
#line 51 "../src/Panes/Audio.vala"
	reader_label = _tmp0_;
#line 53 "../src/Panes/Audio.vala"
	_tmp1_ = accessibility_widgets_settings_box_new ();
#line 53 "../src/Panes/Audio.vala"
	g_object_ref_sink (_tmp1_);
#line 53 "../src/Panes/Audio.vala"
	reader_box = _tmp1_;
#line 54 "../src/Panes/Audio.vala"
	_tmp2_ = reader_box;
#line 54 "../src/Panes/Audio.vala"
	_tmp3_ = accessibility_widgets_settings_box_add_switch (_tmp2_, _ ("Provide audio descriptions for items on the screen"));
#line 54 "../src/Panes/Audio.vala"
	read_items = _tmp3_;
#line 55 "../src/Panes/Audio.vala"
	_tmp4_ = accessibility_panes_audio_get_screenreader_shortcut_keys (self);
#line 55 "../src/Panes/Audio.vala"
	_tmp5_ = _tmp4_;
#line 55 "../src/Panes/Audio.vala"
	_tmp6_ = (GtkLabel*) gtk_label_new (_tmp5_);
#line 55 "../src/Panes/Audio.vala"
	g_object_ref_sink (_tmp6_);
#line 55 "../src/Panes/Audio.vala"
	_data2_->shortcut_label = _tmp6_;
#line 56 "../src/Panes/Audio.vala"
	_tmp7_ = reader_box;
#line 56 "../src/Panes/Audio.vala"
	_tmp8_ = _data2_->shortcut_label;
#line 56 "../src/Panes/Audio.vala"
	accessibility_widgets_settings_box_add_widget (_tmp7_, _ ("Keyboard shortcut"), (GtkWidget*) _tmp8_);
#line 58 "../src/Panes/Audio.vala"
	_tmp9_ = accessibility_widgets_link_label_new (_ ("Sound settings…"), "settings://sound");
#line 58 "../src/Panes/Audio.vala"
	g_object_ref_sink (_tmp9_);
#line 58 "../src/Panes/Audio.vala"
	audio_settings = _tmp9_;
#line 59 "../src/Panes/Audio.vala"
	_tmp10_ = audio_settings;
#line 59 "../src/Panes/Audio.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp10_, TRUE);
#line 61 "../src/Panes/Audio.vala"
	_tmp11_ = accessibility_categories_pane_get_grid ((AccessibilityCategoriesPane*) self);
#line 61 "../src/Panes/Audio.vala"
	_tmp12_ = _tmp11_;
#line 61 "../src/Panes/Audio.vala"
	_tmp13_ = reader_label;
#line 61 "../src/Panes/Audio.vala"
	gtk_container_add ((GtkContainer*) _tmp12_, (GtkWidget*) _tmp13_);
#line 62 "../src/Panes/Audio.vala"
	_tmp14_ = accessibility_categories_pane_get_grid ((AccessibilityCategoriesPane*) self);
#line 62 "../src/Panes/Audio.vala"
	_tmp15_ = _tmp14_;
#line 62 "../src/Panes/Audio.vala"
	_tmp16_ = reader_box;
#line 62 "../src/Panes/Audio.vala"
	gtk_container_add ((GtkContainer*) _tmp15_, (GtkWidget*) _tmp16_);
#line 63 "../src/Panes/Audio.vala"
	_tmp17_ = accessibility_categories_pane_get_grid ((AccessibilityCategoriesPane*) self);
#line 63 "../src/Panes/Audio.vala"
	_tmp18_ = _tmp17_;
#line 63 "../src/Panes/Audio.vala"
	_tmp19_ = audio_settings;
#line 63 "../src/Panes/Audio.vala"
	gtk_container_add ((GtkContainer*) _tmp18_, (GtkWidget*) _tmp19_);
#line 64 "../src/Panes/Audio.vala"
	_tmp20_ = accessibility_categories_pane_get_grid ((AccessibilityCategoriesPane*) self);
#line 64 "../src/Panes/Audio.vala"
	_tmp21_ = _tmp20_;
#line 64 "../src/Panes/Audio.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp21_);
#line 66 "../src/Panes/Audio.vala"
	_tmp22_ = accessibility_plug_applications_settings;
#line 66 "../src/Panes/Audio.vala"
	_tmp23_ = read_items;
#line 66 "../src/Panes/Audio.vala"
	g_settings_bind (_tmp22_, "screen-reader-enabled", (GObject*) _tmp23_, "active", G_SETTINGS_BIND_DEFAULT);
#line 68 "../src/Panes/Audio.vala"
	_tmp24_ = accessibility_panes_audio_media_keys_settings;
#line 68 "../src/Panes/Audio.vala"
	g_signal_connect_data (_tmp24_, "changed", (GCallback) __accessibility_panes_audio___lambda4__g_settings_changed, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 50 "../src/Panes/Audio.vala"
	_g_object_unref0 (audio_settings);
#line 50 "../src/Panes/Audio.vala"
	_g_object_unref0 (read_items);
#line 50 "../src/Panes/Audio.vala"
	_g_object_unref0 (reader_box);
#line 50 "../src/Panes/Audio.vala"
	_g_object_unref0 (reader_label);
#line 50 "../src/Panes/Audio.vala"
	block2_data_unref (_data2_);
#line 50 "../src/Panes/Audio.vala"
	_data2_ = NULL;
#line 50 "../src/Panes/Audio.vala"
	return obj;
#line 731 "Audio.c"
}

static void
accessibility_panes_audio_class_init (AccessibilityPanesAudioClass * klass,
                                      gpointer klass_data)
{
	GSettings* _tmp0_;
#line 23 "../src/Panes/Audio.vala"
	accessibility_panes_audio_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/Panes/Audio.vala"
	g_type_class_adjust_private_offset (klass, &AccessibilityPanesAudio_private_offset);
#line 23 "../src/Panes/Audio.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_accessibility_panes_audio_get_property;
#line 23 "../src/Panes/Audio.vala"
	G_OBJECT_CLASS (klass)->constructor = accessibility_panes_audio_constructor;
#line 23 "../src/Panes/Audio.vala"
	G_OBJECT_CLASS (klass)->finalize = accessibility_panes_audio_finalize;
#line 23 "../src/Panes/Audio.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACCESSIBILITY_PANES_AUDIO_SCREENREADER_SHORTCUT_KEYS_PROPERTY, accessibility_panes_audio_properties[ACCESSIBILITY_PANES_AUDIO_SCREENREADER_SHORTCUT_KEYS_PROPERTY] = g_param_spec_string ("screenreader-shortcut-keys", "screenreader-shortcut-keys", "screenreader-shortcut-keys", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 47 "../src/Panes/Audio.vala"
	_tmp0_ = g_settings_new ("org.gnome.settings-daemon.plugins.media-keys");
#line 47 "../src/Panes/Audio.vala"
	_g_object_unref0 (accessibility_panes_audio_media_keys_settings);
#line 47 "../src/Panes/Audio.vala"
	accessibility_panes_audio_media_keys_settings = _tmp0_;
#line 757 "Audio.c"
}

static void
accessibility_panes_audio_instance_init (AccessibilityPanesAudio * self,
                                         gpointer klass)
{
	gchar* _tmp0_;
#line 23 "../src/Panes/Audio.vala"
	self->priv = accessibility_panes_audio_get_instance_private (self);
#line 26 "../src/Panes/Audio.vala"
	_tmp0_ = g_strdup ("");
#line 26 "../src/Panes/Audio.vala"
	self->priv->_screenreader_shortcut_keys = _tmp0_;
#line 771 "Audio.c"
}

static void
accessibility_panes_audio_finalize (GObject * obj)
{
	AccessibilityPanesAudio * self;
#line 23 "../src/Panes/Audio.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ACCESSIBILITY_PANES_TYPE_AUDIO, AccessibilityPanesAudio);
#line 26 "../src/Panes/Audio.vala"
	_g_free0 (self->priv->_screenreader_shortcut_keys);
#line 23 "../src/Panes/Audio.vala"
	G_OBJECT_CLASS (accessibility_panes_audio_parent_class)->finalize (obj);
#line 784 "Audio.c"
}

static GType
accessibility_panes_audio_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AccessibilityPanesAudioClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) accessibility_panes_audio_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AccessibilityPanesAudio), 0, (GInstanceInitFunc) accessibility_panes_audio_instance_init, NULL };
	GType accessibility_panes_audio_type_id;
	accessibility_panes_audio_type_id = g_type_register_static (ACCESSIBILITY_CATEGORIES_TYPE_PANE, "AccessibilityPanesAudio", &g_define_type_info, 0);
	AccessibilityPanesAudio_private_offset = g_type_add_instance_private (accessibility_panes_audio_type_id, sizeof (AccessibilityPanesAudioPrivate));
	return accessibility_panes_audio_type_id;
}

GType
accessibility_panes_audio_get_type (void)
{
	static volatile gsize accessibility_panes_audio_type_id__once = 0;
	if (g_once_init_enter (&accessibility_panes_audio_type_id__once)) {
		GType accessibility_panes_audio_type_id;
		accessibility_panes_audio_type_id = accessibility_panes_audio_get_type_once ();
		g_once_init_leave (&accessibility_panes_audio_type_id__once, accessibility_panes_audio_type_id);
	}
	return accessibility_panes_audio_type_id__once;
}

static void
_vala_accessibility_panes_audio_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	AccessibilityPanesAudio * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, ACCESSIBILITY_PANES_TYPE_AUDIO, AccessibilityPanesAudio);
#line 23 "../src/Panes/Audio.vala"
	switch (property_id) {
#line 23 "../src/Panes/Audio.vala"
		case ACCESSIBILITY_PANES_AUDIO_SCREENREADER_SHORTCUT_KEYS_PROPERTY:
#line 23 "../src/Panes/Audio.vala"
		g_value_set_string (value, accessibility_panes_audio_get_screenreader_shortcut_keys (self));
#line 23 "../src/Panes/Audio.vala"
		break;
#line 825 "Audio.c"
		default:
#line 23 "../src/Panes/Audio.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Panes/Audio.vala"
		break;
#line 831 "Audio.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

